Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Halide::Internal::StubOutputBuffer< T > Class Template Reference

StubOutputBuffer is the placeholder that a Stub uses when it requires a Buffer for an output (rather than merely a Func). More...

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::StubOutputBuffer< T >:

## Public Member Functions
| StubOutputBuffer ()=default
Public Member Functions inherited from Halide::Internal::StubOutputBufferBase
Realization | realize (std::vector< int32_t > sizes)
template<typename... Args>
Realization | realize (Args &&...args)
template<typename Dst >
void | realize (Dst dst)

## Static Public Member Functions
static std::vector< StubOutputBuffer< T > > | to_output_buffers (const std::vector< Func > &v, const std::shared_ptr< AbstractGenerator > &gen)

## Additional Inherited Members
Protected Member Functions inherited from Halide::Internal::StubOutputBufferBase
Target | get_target () const
| StubOutputBufferBase ()
| StubOutputBufferBase (const Func &f, const std::shared_ptr< AbstractGenerator > &generator)
Protected Attributes inherited from Halide::Internal::StubOutputBufferBase
Func | f
std::shared_ptr< AbstractGenerator > | generator

## Detailed Description

template<typename T = void>
class Halide::Internal::StubOutputBuffer< T >

StubOutputBuffer is the placeholder that a Stub uses when it requires a Buffer for an output (rather than merely a Func).

It is constructed to allow only two possible sorts of things: – Assignment to an Output<Buffer<>>, with compatible type and dimensions, essentially allowing us to pipe a parameter from the result of a Stub to an enclosing Generator – Realization into a Buffer<>; this is useful only in JIT compilation modes (and shouldn't be usable otherwise)

It is deliberate that StubOutputBuffer is not (easily) convertible to Func.

Definition at line 1359 of file Generator.h.

## Constructor & Destructor Documentation

## ◆ StubOutputBuffer()

template<typename T = void>

Halide::Internal::StubOutputBuffer< T >::StubOutputBuffer | ( |  | ) |
| default

## Member Function Documentation

## ◆ to_output_buffers()

template<typename T = void>

static std::vector< StubOutputBuffer< T > > Halide::Internal::StubOutputBuffer< T >::to_output_buffers | ( | const std::vector< Func > & | v,
|  | const std::shared_ptr< AbstractGenerator > & | gen
| ) |  |
| inline static

Definition at line 1369 of file Generator.h.

References Halide::cast(), and Halide::Internal::StubOutputBufferBase::f.

The documentation for this class was generated from the following file:

- src/Generator.h